commit 11195a9e0a46f5204f2506caaea815830d1d9491
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Fri Sep 20 09:14:29 2024 +0200

    i386: Fix up _mm_min_ss etc. handling of zeros and NaNs [PR116738]
    
    min/max patterns for intrinsics which on x86 result in the second
    input operand if the two operands are both zeros or one or both of them
    are a NaN shouldn't use SMIN/SMAX RTL, because that is similarly to
    MIN_EXPR/MAX_EXPR undefined what will be the result in those cases.
    
    The following patch adds an expander which uses either a new pattern with
    UNSPEC_IEEE_M{AX,IN} or use the S{MIN,MAX} representation of the same.
    
    2024-09-20  Uros Bizjak  <ubizjak@gmail.com>
                Jakub Jelinek  <jakub@redhat.com>
    
            PR target/116738
            * config/i386/subst.md (mask_scalar_operand_arg34,
            mask_scalar_expand_op3, round_saeonly_scalar_mask_arg3): New
            subst attributes.
            * config/i386/sse.md
            (<sse>_vm<code><mode>3<mask_scalar_name><round_saeonly_scalar_name>):
            Change from define_insn to define_expand, rename the old define_insn
            to ...
            (*<sse>_vm<code><mode>3<mask_scalar_name><round_saeonly_scalar_name>):
            ... this.
            (<sse>_ieee_vm<ieee_maxmin><mode>3<mask_scalar_name><round_saeonly_scalar_name>):
            New define_insn.
    
            * gcc.target/i386/sse-pr116738.c: New test.
    
    (cherry picked from commit 624d3af025e820ede7ec4334f7a2d5d4731c99a9)

diff --git a/gcc/testsuite/gcc.target/i386/sse-pr116738.c b/gcc/testsuite/gcc.target/i386/sse-pr116738.c
new file mode 100644
index 00000000000..5b31bf24748
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/sse-pr116738.c
@@ -0,0 +1,28 @@
+/* PR target/116738 */
+/* { dg-do run } */
+/* { dg-options "-O2 -msse" } */
+/* { dg-require-effective-target sse } */
+
+#include "sse-check.h"
+
+static inline float
+clamp (float f)
+{
+  __m128 v = _mm_set_ss (f);
+  __m128 zero = _mm_setzero_ps ();
+  __m128 greatest = _mm_set_ss (__FLT_MAX__);
+  v = _mm_min_ss (v, greatest);
+  v = _mm_max_ss (v, zero);
+  return _mm_cvtss_f32 (v);
+}
+
+static void
+sse_test (void)
+{
+  float f = clamp (-0.0f);
+  if (f != 0.0f || __builtin_signbitf (f))
+    abort ();
+  f = clamp (__builtin_nanf (""));
+  if (__builtin_isnanf (f) || f != __FLT_MAX__)
+    abort ();
+}

